<copyright> DNEWS Article class.
    Written by <a href="mailto:tiggr@es.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 1996 Pieter J. Schoenmakers.
    All rights reserved.

    <id>$Id: Article.t,v 1.4 1996/11/25 17:26:24 tiggr Exp $</id>
    </copyright>

implementation class
Article: State, Conditions
{
  <doc> Currently cached articles, on their message_id.  </doc>
  MutableMapped cache;

  <doc> The attributes in which we're interested when fetching an article.
    </doc>
  static Array attributes;

  <doc> The uniqued strings of attribute names.  </doc>
  static String a_oid, a_msg_id, a_expire, a_article;
}

redefine void
  load Array arguments
{
  a_oid = ["oid" uniqueString];
  a_msg_id = ["msg_id" uniqueString];
  a_expire = ["expire" uniqueString];
  a_article = ["article" uniqueString];
  attributes = [ObjectArray with (a_oid, a_msg_id, a_expire, a_article)];

  cache = [MutableDictionary new];
}

<doc> Return the article with the indicated message_id, from the database.
    </doc>
instance (id)
  withMessageID UniqueString message_id
     inDatabase Database db
{
  instance (id) art = cache[message_id];

  if (art)
    = art;
  else
    {
      [db exec [[MutableByteString withCapacity 128]
		 print ("select oid, article from articles where msg_id='",
			message_id, "'")]];

      int n = [db numRows];
      if (n == 1)
	{
	  Mapped row = [db fetchAttributes attributes];
	  art = [[self alloc] initWithIdentity [ObjectID with row[a_oid]]
			      messageID message_id contentsID row[a_article]];
	  cache[message_id] = art;
	  = art;
	}
      else if (n > 1)
	[[[Server errorStream]
	  print ("WARNING ", n, " articles with message-id ", message_id)] nl];
    }
}

<doc> Return a newly created {Article}, which will actually be inserted
    into the database before this method returns.  No check is done on
    duplicate message-ids.  </doc>
instance (id)
  createWithContents ByteArray contents
	   messageID UniqueString message_id
	  inDatabase Database db
{
  instance (id) result;
  ObjectID oid;

  oid = [db largeObjectCreate contents];
  [db exec [[MutableByteString withCapacity 128]
	     print ("insert into articles (msg_id, article) values ('",
		    message_id, "', ", oid, ")")]];
  = [[self alloc] initWithIdentity [db resultOfInsert]
		  messageID message_id contentsID oid contents: contents];
}

end;

implementation instance
Article
{
  <doc> Our key into the database.  </doc>
  public ObjectID oid;

  <doc> Our message-id.  </doc>
  public UniqueString message_id;

  <doc> The key to our contents.  </doc>
  ObjectID contents_id;

  <doc> Our contents, or 0 if not yet fetched.  </doc>
  ByteArray contents;
}

ByteArray
  contents
{
  if (!contents)
    contents = [[Server database] largeObjectRetrieve contents_id];
  = contents;
}

protected id
  initWithIdentity ObjectID identity
	 messageID UniqueString msg_id
	contentsID ObjectID c_id
	 contents: ByteArray body = nil
{
  (oid, message_id, contents_id, contents) = (identity, msg_id, c_id, body);

  = self;
}

redefine OutputStream
  write OutputStream s
{
  = [s print ("#<", [isa name], " ", [self address], " ",
	      message_id, " ", oid, " ", contents_id, ">")];
}

end;
