<copyright> DNEWS Database abstraction.
    Written by <a href="mailto:tiggr@es.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 1996 Pieter J. Schoenmakers.
    All rights reserved.

    <id>$Id: Database.t,v 1.2 1996/08/16 14:52:59 tiggr Exp $</id>
    </copyright>

/******************** Database ********************/

implementation class
Database

end;

implementation instance
Database

/********** queries **********/

<doc> Execute the {query}.  </doc>
deferred void
  exec String query;

/********** query results **********/

<doc> Return the attribute names in the result of the most recent fetch.
    </doc>
deferred Indexed
  attributes;

<doc> Return the number of rows in the result of the last query.  </doc>
deferred int
  numRows;

<doc> Return the next row from the most recent fetch.  The fields are
    ordered identical to the collection returned by {attributes}.  </doc>
deferred MutableIndexed
  nextRow;

<doc> Return the next row from the most recent fetch as a mapped collection
    containing as a key each of the elements in the {attributes}.  </doc>
deferred MutableMapped
  fetchAttributes Indexed attributes;

/********** transactions **********/

deferred void
  begin;

deferred void
  commit;

deferred void
  abort;

/********** modification results **********/

<doc> Return the identity of the object which was inserted into the
    database by the last insert command.  </doc>
deferred ObjectID
  resultOfInsert;

/********** large objects **********/

// Maybe these should reside in a genuine LargeObject class...
// Tue Aug 13 17:40:59 1996, tiggr@viper.es.ele.tue.nl

<doc> Create a new large object from the {contents}, and return its
    identity.  </doc>
deferred ObjectID
  largeObjectCreate ByteArray contents;

<doc> Retrieve the large object identified by its {identity}.  </doc>
deferred ByteArray
  largeObjectRetrieve ObjectID identity;

end;

/******************** ObjectID ********************/

<doc> The {ObjectID} is an abstract class for identifying large objects
    stored in the database.  </doc>
implementation class
ObjectID

end;

implementation instance
ObjectID
end;
