<copyright> DNEWS Group class.
    Written by <a href="mailto:tiggr@es.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 1996 Pieter J. Schoenmakers.
    All rights reserved.

    <id>$Id: Group.t,v 1.5 1996/11/25 17:26:26 tiggr Exp $</id>
    </copyright>

/******************** Group ********************/

implementation class
Group: State
{
  <doc> All groups we know.  </doc>
  static MutableDictionary groups;

  <doc> The attributes in which we're interested when fetching a group.  </doc>
  static Array attributes;

  <doc> The uniqued strings of attribute names.  </doc>
  static String a_oid, a_name, a_first, a_last;
}

void
  load Array arguments
{
  a_oid = ["oid" uniqueString];
  a_name = ["name" uniqueString];
  a_first = ["first" uniqueString];
  a_last = ["last" uniqueString];

  attributes = [ObjectArray with (a_oid, a_name, a_first, a_last)];
}

id
  classForGroupNamed String name
{
  = ["control" equal name] ? [Control self] : self;
}

Mapped
  groups
{
  = groups;
}

void
  initializeFrom Database database
{
  Keyed next;

  groups = [MutableDictionary new];

  [database exec "select oid, name, first, last from groups"];

  while (!!(next = [database fetchAttributes attributes]))
    {
      instance (id) g = [[[self classForGroupNamed next["name"]]
			  alloc] init next];

      groups[[g name]] = g;
      [[[Server errorStream] print ("read ", g)] nl];
    }
}

instance (id)
  named String name
{
  = groups[name];
}

end;

implementation instance
Group
{
  <doc> The name of this group.  </doc>
  public String name;

  <doc> This group's key in the database.  </doc>
  public ObjectID oid;

  <doc> Cached values from the database.  </doc>
  public int first, last;
}

AinG
  aingForArticle Article a
{
  Database db = [Server database];
  boolean failed = YES;
  AinG assoc;

  last++;
  unwind ({if (failed) last--;})
    ({
      assoc = [AinG createArticle a withNumber last inGroup self inDatabase db];
      [db exec [[MutableByteString withCapacity 512]
		print ("update groups set last=", last, " where oid=", oid)]];

      failed = NO;
    });

  = assoc;
}

protected id
  init Keyed attributes
{
  oid = [ObjectID with [attributes[a_oid] intValue]];
  name = attributes[a_name];
  first = [attributes[a_first] intValue];
  last = [attributes[a_last] intValue];

  = self;
}

redefine OutputStream
  write OutputStream s
{
  = [s print ("#<", [isa name], " ", [self address], " ", name,
	      " ", oid, " ", first, " ", last, ">")];
}

end;

/******************** Control ********************/

implementation class
Control: Group
end;

implementation instance
Control
end;
