<copyright> DNEWS Postgres database.
    Written by <a href="mailto:tiggr@es.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 1996 Pieter J. Schoenmakers.
    All rights reserved.

    <id>$Id: Postgres.t,v 1.3 1996/11/25 17:26:27 tiggr Exp $</id>
    </copyright>

/******************** Database (Postgres) ********************/

implementation class
Database extension Postgres

instance (id)
  connect String database
    host: String hostname = [Runtime hostname]
{
  = [Postgres connect database host: hostname];
}

end;

implementation instance
Database extension Postgres
end;

/******************** Postgres ********************/

implementation class
Postgres: Database, State

redefine instance (id)
  connect String database
    host: String hostname
{
  = [[self alloc] init (database, hostname)];
}

end;

implementation instance
Postgres
{
  <doc> The libpq connection abstraction.  </doc>
  pointer connection;

  <doc> Some information cached from the above.  </doc>
  public String hostname;
  public String name;

  <doc> The result of the most recent query.  </doc>
  pointer result;

  <doc> The index of the next row to be fetched.  </doc>
  int next_row;
}

extern void
  close;

redefine extern void
  dealloc;

extern id
  init (String, String) (name, hostname);

/********** Database **********/

extern void
  exec String query;

extern int
  numRows;

extern Indexed
  attributes;

extern MutableIndexed
  nextRow;

extern MutableMapped
  fetchAttributes Indexed attributes;

extern ObjectID
  resultOfInsert;

extern ObjectID
  largeObjectCreate ByteArray contents;

extern ByteArray
  largeObjectRetrieve ObjectID identity;

void
  begin
{
  [self exec "begin"];
}

void
  commit
{
  [self exec "end"];
}

void
  abort
{
  [self exec "abort"];
}

end;

/******************** ObjectID ********************/

implementation class
ObjectID extension Postgres: IntNumber

instance (id)
  with String string_rep
{
  = [self with [string_rep intValue]];
}

end;

implementation instance
ObjectID extension Postgres
end;
