-- crdb.sql: create tables in dnews database
-- Written by Pieter J. Schoenmakers <tiggr@es.ele.tue.nl>
--
-- Copyright (C) 1996 Pieter J. Schoenmakers
-- All rights reserved.
--
-- $Id: crdb.sql,v 1.3 1996/08/16 14:53:04 tiggr Exp $

-- Feed this to postgres using, for instance by typing:
--	psql -d dnews -f crdb.sql
--
-- Do not execute this script lightly as it resets all groups' local
-- article counters!

drop table articles;
create table
articles
(
  -- The message id of the article.
  msg_id		text

  -- When to remove this article from the database.
  , expire		abstime

  -- the object holding this article's contents.
  , article		oid
);

-- create index article_idx on articles using hash (oid oid_ops);
-- create index msg_id_idx on articles using hash (msg_id text_ops);

drop table groups;
create table
groups
(
  -- The name of the group.
  name			text

  -- The lowest article number from this group present in the database.
  , first		int4

  -- The article number of the last article entered.  A new article will
  -- get as an article number one plus this value.
  , last		int4
);

drop table a_in_g;
create table
a_in_g
(
  -- The group.
  group_id		oid

  -- The article's message id.
  , msg_id		text

  -- The local article number in the group.
  , number		int4
);

-- Create important groups.
insert into groups (name, first, last) values ('test', 1, 0);
insert into groups (name, first, last) values ('control', 1, 0);
insert into groups (name, first, last) values ('news.software.d', 1, 0);
